diff --git a/tests/imfile-logrotate-async.sh b/tests/imfile-logrotate-async.sh
index c15a69d24b..8815dfb2e8 100755
--- a/tests/imfile-logrotate-async.sh
+++ b/tests/imfile-logrotate-async.sh
@@ -6,6 +6,10 @@ check_command_available logrotate
 export NUMMESSAGES=10000
 export RETRIES=50
 
+# Uncomment fdor debuglogs
+#export RSYSLOG_DEBUG="debug nostdout noprintmutexaction"
+#export RSYSLOG_DEBUGLOG="$RSYSLOG_DYNNAME.debuglog"
+
 # Write logrotate config file
 echo '"./'$RSYSLOG_DYNNAME'.input*.log"
 {
@@ -41,27 +45,30 @@ if $msg contains "msgnum:" then
 '
 startup
 
-./inputfilegen -m $NUMMESSAGES -S 5 -B 500 -f $RSYSLOG_DYNNAME.input.log &
+./inputfilegen -m $NUMMESSAGES -S 1 -B 100 -I 1000 -f $RSYSLOG_DYNNAME.input.log &
 INPUTFILEGEN_PID=$!
 echo "$INPUTFILEGEN_PID" > $RSYSLOG_DYNNAME.inputfilegen_pid
 
-
-
 ./msleep 1
 logrotate --state $RSYSLOG_DYNNAME.logrotate.state -f $RSYSLOG_DYNNAME.logrotate
 ./msleep 20
-echo INPUT FILES:
+echo ======================:
+echo ROTATE 1	INPUT FILES:
 ls -li $RSYSLOG_DYNNAME.input*
 logrotate --state $RSYSLOG_DYNNAME.logrotate.state -f $RSYSLOG_DYNNAME.logrotate
 ./msleep 20
-echo INPUT FILES:
+echo ======================:
+echo ROTATE 2	INPUT FILES:
 ls -li $RSYSLOG_DYNNAME.input*
 logrotate --state $RSYSLOG_DYNNAME.logrotate.state -f $RSYSLOG_DYNNAME.logrotate
-echo INPUT FILES:
+echo ======================:
+echo ROTATE 3	INPUT FILES:
 ls -li $RSYSLOG_DYNNAME.input*
+echo ======================:
 echo ls ${RSYSLOG_DYNNAME}.spool:
 ls -li ${RSYSLOG_DYNNAME}.spool
-echo INPUT FILES:
+echo ======================:
+echo FINAL	INPUT FILES:
 ls -li $RSYSLOG_DYNNAME.input*
 
 # generate more input after logrotate into new logfile
@@ -70,6 +77,17 @@ ls -li $RSYSLOG_DYNNAME.input*
 
 #msgcount=$((2* TESTMESSAGES))
 #wait_file_lines $RSYSLOG_OUT_LOG $msgcount $RETRIES
+	./msleep 1000
+	echo ======================:
+	echo LINES:	$(wc -l $RSYSLOG_DYNNAME.input.log)
+	echo TAIL	$RSYSLOG_DYNNAME.input.log:
+	tail $RSYSLOG_DYNNAME.input.log
+	echo LINES:	$(wc -l $RSYSLOG_DYNNAME.input.log.1)
+	echo TAIL	$RSYSLOG_DYNNAME.input.log.1:
+	tail $RSYSLOG_DYNNAME.input.log.1
+	echo LINES:	$(wc -l $RSYSLOG_DYNNAME.input.log.2)
+	echo TAIL	$RSYSLOG_DYNNAME.input.log.2:
+	tail $RSYSLOG_DYNNAME.input.log.2
 wait_file_lines
 
 touch $RSYSLOG_DYNNAME.input.log
diff --git a/tests/inputfilegen.c b/tests/inputfilegen.c
index ef61229ab1..6c689672fa 100644
--- a/tests/inputfilegen.c
+++ b/tests/inputfilegen.c
@@ -52,7 +52,7 @@ static volatile int bHadHUP = 0;
 static void
 hdlr_sighup(int sig)
 {
-	fprintf(stderr, "had hup, sig %d\n", sig);
+	fprintf(stderr, "inputfilegen: had hup, sig %d\n", sig);
 	bHadHUP = 1;
 }
 static void
@@ -95,6 +95,7 @@ int main(int argc, char* argv[])
 	int c, i;
 	long long nmsgs = DEFMSGS;
 	long long nmsgstart = 0;
+	int nfinishedidle = 0;
 	int nchars = NOEXTRADATA;
 	int errflg = 0;
 	long long filesize = -1;
@@ -106,7 +107,7 @@ int main(int argc, char* argv[])
 	int sleep_msgs = 0; /* messages to xmit between sleeps (if configured) */
 	int ctr = 0;
 
-	while((c=getopt(argc, argv, "m:M:i:d:s:f:S:B:")) != -1) {
+	while((c=getopt(argc, argv, "m:M:i:I:d:s:f:S:B:")) != -1) {
 		switch(c) {
 		case 'm':
 			nmsgs = atoi(optarg);
@@ -117,6 +118,9 @@ int main(int argc, char* argv[])
 		case 'i':
 			nmsgstart = atoi(optarg);
 			break;
+		case 'I':
+			nfinishedidle = atoi(optarg);
+			break;
 		case 'd':
 			nchars = atoi(optarg);
 			break;
@@ -138,7 +142,7 @@ int main(int argc, char* argv[])
 			errflg++;
 			break;
 		case '?':
-			fprintf(stderr, "Unrecognized option: -%c\n", optopt);
+			fprintf(stderr, "inputfilegen: Unrecognized option: -%c\n", optopt);
 			errflg++;
 			break;
 		}
@@ -151,11 +155,11 @@ int main(int argc, char* argv[])
 	if(filesize != -1) {
 		const int linesize = (17 + nchars); /* 17 is std line size! */
 		nmsgs = filesize / linesize;
-		fprintf(stderr, "file size requested %lld, actual %lld with "
+		fprintf(stderr, "inputfilegen: file size requested %lld, actual %lld with "
 			"%lld lines, %lld bytes less\n",
 			filesize, nmsgs * linesize, nmsgs, filesize - nmsgs * linesize);
 		if(nmsgs > 100000000) {
-			fprintf(stderr, "number of lines exhaust 8-digit line numbers "
+			fprintf(stderr, "inputfilegen: number of lines exhaust 8-digit line numbers "
 				"which are standard inside the testbench.\n"
 				"Use -d switch to add extra data (e.g. -d111 for "
 				"128 byte lines or -d47 for 64 byte lines)\n");
@@ -192,7 +196,8 @@ int main(int argc, char* argv[])
 		if(bHadHUP) {
 			fclose(fh_output);
 			fh_output = open_output(outputfile);
-			fprintf(stderr, "%s reopened\n", outputfile);
+			fprintf(stderr, "inputfilegen: %s reopened\n", outputfile);
+			fprintf(stderr, "inputfilegen: current message number %d\n", i);
 			bHadHUP = 0;
 		}
 		fprintf(fh_output, "msgnum:%8.8d:", i);
@@ -201,6 +206,20 @@ int main(int argc, char* argv[])
 		}
 		fprintf(fh_output, "\n");
 	}
+	if (nfinishedidle > 0) {
+		/* Keep process open for nfinishedidle ms */
+		for(int x = 0; x < nfinishedidle; ++x) {
+			if(bHadHUP) {
+				/* Create empty file */
+				fh_output = open_output(outputfile);
+				fclose(fh_output);
+				fprintf(stderr, "inputfilegen: last message number was %d\n", i);
+				bHadHUP = 0;
+			}
+			msleep(1);
+		}
+	}
+
 	free(extradata);
 	return 0;
 }
